#include <stdio.h>
#include <omp.h>
#define N 10
int main(void) {
	float a[N], b[N], c[N];
	int i, TID, nthreads;
	omp_set_num_threads(3);
#pragma omp parallel default(none), private(i), shared(a,b)
	{
#pragma omp for
		for (i = 0; i < N; i++) {
			a[i] = (i + 1) * 1.0;
			b[i] = (i + 1) * 2.0;
		}
	}
#pragma omp parallel default(none), private(i,TID), shared(a,b,c,nthreads)
	{
		TID = omp_get_thread_num();
		if (TID == 0) {
			nthreads = omp_get_num_threads();
			printf("Number of threads = (%d) \n", nthreads);
		}
		printf("Thread %d starting \n", TID);
#pragma omp for
		for (i = 0; i < N; i++) {
			c[i] = a[i] + b[i];
			printf("%d, %d, %f, %f, %f \n", TID, i + 1, a[i], b[i], c[i]);
		}
	}
}