#include <stdio.h>
#include <omp.h>
#define N 5

void list_2D_table(int tab[][N], int n_rows, int n_cols)
{
	int i, j;
	for (i = 0; i < n_rows; i++) {
		for (j = 0; j < n_cols; j++)
			printf("%d ", tab[i][j]);
		printf("\n");
	}
	printf("\n");
}



void list_1D_table(float tab[], int size)
{
	int i;
	for (i = 0; i < size; i++)
		printf("%f ", tab[i]);
	printf("\n");
	printf("\n");
}

float a[N] = { 4.1f,3.2f,1.4f,5.2f,10.8f };
float b[N] = { 0.0f,0.0f,0.0f,0.0f,0.0f };
int w[N][N];
int ind[N];
int i, j;

int main(void)
{
#pragma omp parallel default(none), private(i,j), shared(a,b,w,ind)
	{
#pragma omp for
		for (i = 0; i < N; i++) {
			for (j = 0; j < N; j++) {
				if ((a[i] > a[j]) || (a[i] == a[j] && i > j))
					w[i][j] = 1;
				else
					w[i][j] = 0;
			}
		}
	}
#pragma omp parallel default(none), private(i,j), shared(a,b,w,ind)
	{
#pragma omp for
		for (i = 0; i < N; i++) {
			for (j = 0; j < N; j++) {
				ind[i] += w[i][j];
			}
			b[ind[i]] = a[i];
		}
	}
	list_1D_table(a, N);
	list_2D_table(w, N, N);
	list_1D_table(b, N);
	return 0;
}